/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MFTIMER_
#define _MFTIMER_

#include <stdio.h>
#include <time.h>

#ifdef POSIX
#include <unistd.h>
#define ONE_SECOND CLOCKS_PER_SEC

typedef unsigned long 	DWORD;
typedef unsigned char 	BOOL;
typedef unsigned int 	HANDLE;

#endif

#ifdef Win32
#define clock		GetTickCount	
#define ONE_SECOND	1000
#endif


#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

/** A class to function timing. */
class MFTimer
{

	public:
	virtual	void		BoostPriority(void);
	virtual	void		DropPriority(void);
	virtual void		TimeLoop(unsigned count);
	virtual DWORD		TickWait();
	virtual DWORD		TickTime(unsigned count);
	virtual double		CountToMicro(unsigned count);
	virtual double		MeasureFast(BOOL fQuiet=TRUE);
	virtual double		MeasureSlow(BOOL fQuiet=TRUE);
	virtual unsigned	Calibrate(BOOL fQuiet=TRUE);
};
#endif
