/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MLIST_
#define _MLIST_

/** a list of MNodes */
class MList : public MNode, public MNodeHolder
{
	protected:
	int m_count;
	MNode *m_First;
	MNode *m_Last;
	public:
	MList();

	virtual ~MList();
	int count(void);
	virtual void 	DeleteAll(EnumFn fn, void *p1, void *p2);
	virtual void FirstAdd(MNode *mn);
	virtual MNode *FirstGet(Boolean fRemove=FALSE);
	virtual void LastAdd(MNode *mn);
	virtual MNode *LastGet(Boolean fRemove=FALSE);
	inline	MNode *pop(void) {return LastGet(TRUE); };
	inline	void push(MNode *mn) {LastAdd(mn); };
	virtual	void pull(MNode *mn);
	// MNodeHolder
	Boolean Insert(MNode *mn);
	MNode * Find(NKey key);

	/** Lists are not sorted so ascending is ignored */
	void 	Enum(EnumFn fn, void *param1=NULL, void *param2=NULL, Boolean ascending=TRUE);
	
	
};
#endif
