/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MSQL_
#define _MSQL_

enum sql_errors
{
	SQLERR_OK,
	SQLERR_OK_DATA,
	SQLERR_BAD
};

typedef void * SQLRESULT;

/** A base class for SQL objects. ODBC is better, but a pain to setup */
class MSql
{
	public:


	SQLRESULT  ExecfResult(char *fmt, ...);
	int 	   Execf(char *fmt, ...);

	/* Virtual functions which do not need to be replace
	   unless yor SQL needs something different
	*/
	virtual	Boolean		Begin(void);
	virtual	Boolean		Close(char *curs);
	virtual	Boolean		Commit(void);
	virtual	Boolean		Cursor(char *name, char *sql, Boolean fBinary);	

	/* virtual functions to be replaced by implementer */
	virtual ~MSql()=0;
	virtual SQLRESULT  ExecResult(char *sql)=0;
	virtual int 	   Exec(char *szsql)=0;
	virtual SQLRESULT  Fetch(int num, char *curs)=0;
	virtual	int 	   ColumnCount(SQLRESULT res)=0;
	virtual	int 	   RowsCount(SQLRESULT res)=0;
	virtual int 	   ColumnIndex(SQLRESULT res, char *key)=0;
	virtual char *	   ColumnValue(SQLRESULT res, int row, int ndx)=0;
	virtual char *	   ColumnName(SQLRESULT res, int ndx)=0;
	virtual void	   FreeResult(SQLRESULT sqlres)=0;
};

#ifdef POSTGRESQL
MSql *NewMPGSql(char *host, char *db, char *port = NULL);
#endif
#endif
