/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _STRFUNCTIONS_
#define _STRFUNCTIONS_

#ifdef WIN32
STRDECL int strcasecmp(char *str1, char *str2)
{
	int diff=0;
	while(diff == 0 && *str1)
	{
		diff = tolower(*str1) - tolower(*str2);
		str1++;
		str2++;
	}
	return diff;
}
#endif

STRDECL int _ncasematch_(unsigned char *string, unsigned char *pattern)
{
	while(*pattern)
		if(g_toupper_tbl[*pattern++] != g_toupper_tbl[*string++])
			return 0;
	return 1;
}
STRDECL int ncasematch(char *str, char *pat)
{
	return _ncasematch_((unsigned char *)str,(unsigned char *)pat);
}
STRDECL char *strcasestr(char *hay, char *needle)
{
	int c = g_toupper_tbl[UCP(needle)[0]];
	register unsigned char *haystack = (unsigned char *)hay;

	while(*haystack)
	{
		if(g_toupper_tbl[*haystack] == c)
		{
			unsigned char *pattern = (unsigned char *) (needle+1);
			unsigned char *string = haystack+1;
			while(*pattern)
				if(g_toupper_tbl[*pattern++] != g_toupper_tbl[*string++])
					break;
			if(!*pattern)
				return (char *)haystack;
		}
		haystack++;
	}
	return NULL;
}


STRDECL char *strrev(char *p)
{
	char *szT = p;
	register int cb= strlen(p)-1;

	for(int i=0;i<cb;i++,cb--)
	{
		register char c = p[i];
        	p[i]=p[cb];
        	p[cb]=c;
    	} 
	return szT;
}


STRDECL char *trim(char *s)
{
	char *pend;
	while(isspace(*s))
		s++;

	pend = &s[strlen(s)-1];
	while( (pend > s) && isspace(*pend))
		pend--;

	pend[1]=0;
	return s;
}

STRDECL char *stripnl(char *s)
{
	char *p=&s[strlen(s)-1];
	while(p > s)
	{
		if(*p == 0x0A || *p == 0x0D)
			*p--=0;
		else
			break;
	}
	return s;
}

STRDECL char *stripnl2lo(char *dest, char *src)
{
	char *ret = dest;
        while(*src)
	{
		*dest = g_tolower_tbl[(unsigned char)*src];
		if(*src==0x0A || *src==0x0D)
			break;
		dest++;
		src++;
	}
	*dest++=0;
        return ret;
}

STRDECL char *stripnl2lo(char *str)
{
	register char *szT=str;

        while(*szT)
	{
		if(*szT==0x0A || *szT==0x0D)
			*szT--=0;
		else
                	*szT++ = g_tolower_tbl[*szT];
	}
	*szT++=0;
        return str;                                                          
}
STRDECL int match(char *str, char *pat)
{
	register char *pattern = pat;
	register char *string = str;

	while(*pattern)
	{
		if(*pattern++ != *string++)
			return 0;
	}

	return 1;
}
#endif
