/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#ifndef _MINTREE_
#define _MINTREE_

typedef struct __mntree
{
	int next;
	int prev;
	int height;
	int key;
	int value;
}MINT;

typedef Boolean (*MINTWalk)(MINT *pmint, void *p1);

// A simplified integer tree.
class MIntTree
{
	protected:
	int	m_def;
	int 	m_top;
	Boolean	m_state;
	MTArray<MINT>m_nodes;

        int SingleRotateLeft(int ndx);
	int SingleRotateRight(int ndx);
	int DoubleRotateLeft(int ndx);
	int DoubleRotateRight(int ndx);
	Boolean TreeWalkUp(int ndx, MINTWalk fn, void *p1);
	Boolean TreeWalkDn(int ndx, MINTWalk fn, void *p1);

	public:
	MIntTree(void) : m_nodes(10000000)
	{
		m_top = -1;
		m_def = 0;
	}

	int & operator [] (int key);
	int Insert(int ndx, MINT *insert);
	void Enum(MINTWalk fn, void *p1, Boolean asc);

};
#endif
