/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 

#include "reqclient.h"

enum REQ_ERRORS
{
	REQE_NOERROR=0,
	REQE_NOSESSION,
	REQE_DUPSESSION,
	REQE_NOWLOCK,
	REQE_NOVALUE,
	REQE_LOCKED,
	REQE_NOSEND,
	REQE_NOCONNECT,
	REQE_BADCONN,
	REQE_BADHDR,
	REQE_BADVER,
	REQE_BADLEN,
	REQE_BUFFER,
	REQE_DENIED,
	REQE_NOFN,
	REQE_UNKNOWN
};

enum REQ_PLUGIN_MSG
{
	REQ_PLUGIN_PULSE=PLUGMSG_START,
	REQ_PLUGIN_SESSION_FLUSH,
	REQ_PLUGIN_SESSION_CREATE,
	REQ_PLUGIN_SESSION_INIT,
	REQ_PLUGIN_SESSION_DESTROY,
	REQ_PLUGIN_ESCAPE,
	REQ_PLUGIN_RELAY,
	REQ_PLUGIN_SERIALIZE,
	REQ_PLUGIN_RESTORE,
	REQ_PLUGIN_LAST
};

/** During a serialize operation, this structure is used to maintain
    state within the plugin */
typedef struct _plugin_serialize
{
	int  		cmd;		// Command to the plugin
	Session * 	session;	// Session, or NULL
	int  		n_var1;		// plugin integer variable 1
	int  		n_var2;		// plugin integer variable 2
	void *		vp_var1;	// plugin pointer variable 1
	void *		vp_var2;	// plugin pointer variable 2
}SERIALIZE_PARAM;

#define PLUGIN_SERIALIZE_BEGIN		1
#define PLUGIN_SERIALIZE_SESSION	2
#define PLUGIN_SERIALIZE_END		3

#define VERSION 44
#define VMULTI	45

#ifdef MSESSION_INTERNAL
typedef int (*reqfunct)(REQB * *preq);
extern reqfunct rfunctions[];
#endif

extern int g_session_timeout_default;
